org.apache.lucene.facet.search

## Interface CategoryListIterator

All Known Implementing Classes:
  DocValuesCategoryListIterator, MultiCategoryListIterator

    public interface CategoryListIterator

An interface for obtaining the category ordinals of documents. `getOrdinals(int, IntsRef)` calls are done with document IDs that are local to the reader given to `setNextReader(AtomicReaderContext)`.

NOTE: this class operates as a key to a map, and therefore you should implement `equals()` and `hashCode()` for proper behavior.

WARNING: This API is experimental and might change in incompatible ways in the next release.

### Method Summary

Methods
`void` `getOrdinals(int docID, IntsRef ints)` Stores the category ordinals of the given document ID in the given `IntsRef`, starting at position 0 upto `IntsRef.length`.
`boolean` `setNextReader(AtomicReaderContext context)` Sets the `AtomicReaderContext` for which `getOrdinals(int, IntsRef)` calls will be made.

### Method Detail

#### setNextReader

    boolean setNextReader(AtomicReaderContext context)
                          throws IOException

Sets the `AtomicReaderContext` for which `getOrdinals(int, IntsRef)` calls will be made. Returns true iff any of the documents in this reader have category ordinals. This method must be called before any calls to `getOrdinals(int, IntsRef)`.

Throws:
  `IOException`

#### getOrdinals

    void getOrdinals(int docID,
                   IntsRef ints)
                     throws IOException

Stores the category ordinals of the given document ID in the given `IntsRef`, starting at position 0 upto `IntsRef.length`. Grows the `IntsRef` if it is not large enough.

NOTE: if the requested document does not have category ordinals associated with it, `IntsRef.length` is set to zero.

Throws:
  `IOException`